package com.keyborad.theme.trendyborad.trendyuiactivity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.activity.EdgeToEdge;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.google.android.material.tabs.TabLayout;
import com.keyborad.theme.trendyborad.R;
import com.keyborad.theme.trendyborad.databinding.ActivityCaTrendyBinding;
import com.keyborad.theme.trendyborad.trendyuifragment.TrendyFragmentFavoriteKeyboard;
import com.keyborad.theme.trendyborad.trendyuifragment.TrendyFragmentHome;
import com.keyborad.theme.trendyborad.trendyutils.TrendyCustomTextView;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class TrendyCategoryActivity extends AppCompatActivity {

    private ActivityCaTrendyBinding vb;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        vb = ActivityCaTrendyBinding.inflate(getLayoutInflater());
        EdgeToEdge.enable(this);
        setContentView(vb.getRoot());
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        init();

    }

    private void init() {
       List<Fragment> listFragment = new ArrayList<>();
        listFragment.add(TrendyFragmentHome.newInstance());
        listFragment.add(TrendyFragmentFavoriteKeyboard.newInstance());

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = vb.tabLayout.newTab();

            View inflate = LayoutInflater.from(this).inflate(R.layout.tab_custom_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
            TrendyCustomTextView textView = inflate.findViewById(R.id.textView);
            if (i == 0) {
                textView.setSelected(true);
                textView.setText(getString(R.string.tab_home));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_home));
            } else if(i ==1){
                textView.setSelected(false);
                textView.setText(getString(R.string.tab_favorite));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_like));
            }
            tab.setCustomView(inflate);
            vb.tabLayout.addTab(tab);
        }


        vb.viewpager.setUserInputEnabled(false);
        vb.viewpager.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bing();
    }


    private void bing() {
        vb.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                vb.viewpager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        vb.viewpager.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(vb.tabLayout.getTabAt(position)).select();
            }
        });
    }


    @Override
    protected void onResume() {
        super.onResume();

    }


}